/**************************************************************************/
/* Outline.c - the layout for triton.library and some stubs for reqtools  */
/**************************************************************************/

#include "GenerateIndex.h"

static UBYTE ScrTitle[] = "GenerateIndex " VERSION " by Anders Melchiorsen";

struct TR_Dimensions EditDimensions, OptionsDimensions;

STRPTR FileTypeOptions[] = {
    "Ignore",
    "AutoDocs",
    NULL
};

#define CheckBoxText(txt, id) VertGroup, HorizGroupSC, Space, CheckBox((id)), SpaceS, TextN((txt)), TRAT_ID, (id), Space, EndGroup, EndGroup

/// MainOutline
ProjectDefinition(MainOutline)
{
    WindowID(WINDOW_MAIN_ID),
        WindowTitle("GenerateIndex"), 
        ScreenTitle(ScrTitle),
        WindowBackfillWin,
        WindowPosition(TRWP_CENTERDISPLAY),

    BeginMenu("Project"),
        MenuItem("Clear", MAIN_MENU_PROJECT_CLEAR),
        ItemBarlabel,
        MenuItem("L_Load data...", MAIN_MENU_PROJECT_LOAD),
        MenuItem("S_Save data...", MAIN_MENU_PROJECT_SAVE),
        ItemBarlabel,
        MenuItem("O_Options...", MAIN_MENU_PROJECT_OPTIONS),
        ItemBarlabel,
        MenuItem("?_About...", MAIN_MENU_PROJECT_ABOUT),
        ItemBarlabel,
        MenuItem("Q_Quit", MAIN_MENU_PROJECT_QUIT),

    VertGroupA,

        Space,

        HorizGroupA,
            Space,

            GroupBox, ObjectBackfillB,
            VertGroupA,

                Space,
                HorizGroupA,
                    Space,
                    ListSS(&FileList, MAIN_LIST_ID, 0, 0),
                        TRAT_MinWidth,  30,
                        TRAT_MinHeight, 10,
                    Space,
                EndGroup,

                SpaceS,

                HorizGroupAC,
                    Space,
                    TextN("References"),
                    SpaceS,
                    IntegerBox(0, MAIN_REFERENCES_ID, 3),
                    Space,
                EndGroup,

                Space,

            EndGroup,
            Space,
        EndGroup,
        Space,

        HorizGroupE,
            Space,
            Button("_Add...", MAIN_ADD_ID),
            ButtonR("_Edit...", MAIN_EDIT_ID),
            Button("_Rescan", MAIN_RESCAN_ID),
            Button("_Delete", MAIN_DELETE_ID),
            Space,
        EndGroup,

        Space,

    EndGroup,
EndProject
};
///

/// EditOutline
ProjectDefinition(EditOutline)
{
    WindowID(WINDOW_EDIT_ID),
        WindowTitle("Edit references"),
        ScreenTitle(ScrTitle),
        WindowBackfillWin,
        WindowPosition(TRWP_CENTERDISPLAY),
        WindowFlags(TRWF_NOCLOSEGADGET),
        WindowDimensions(&EditDimensions),

    VertGroupA,

        Space,

        HorizGroupA,
            Space,

            GroupBox, ObjectBackfillB,
            VertGroupA,

                Space,

                HorizGroupA,
                    Space,
                    ListSS(NULL, EDIT_LIST_ID, 0, 0),
                        TRAT_MinWidth,  30,
                        TRAT_MinHeight, 10,
                    Space,
                EndGroup,

                SpaceS,

                HorizGroupA,
                    LineArray,

#ifdef HAD_TRITON_JUST_WORKED
                        Space,
                        BeginLine,
                            Space,
                            TextNR("Name"),
                            SpaceS,
                            
                            /* Text gadget */
                            _TextBox, ObjectBackfillB, 
                            VertGroup,
                                SpaceS, 
                                HorizGroupSC,
                                    Space,
                                    TextN(""),
                                        TRAT_ID, EDIT_NAME_ID,
                                        TRAT_Flags, TRTX_NOUNDERSCORE,
                                    Space,
                                EndGroup,
                                SpaceS,
                            EndGroup,

                            Space,
                        EndLine,

                        Space,
                        BeginLine,
                            Space,
                            TextNR("File"),
                            SpaceS,
                            
                            /* Text gadget */
                            _TextBox, ObjectBackfillB,
                            VertGroup,
                                SpaceS, 
                                HorizGroupSC,
                                    Space,
                                    TextN(""),
                                        TRAT_ID, EDIT_FILE_ID,
                                        TRAT_Flags, TRTX_NOUNDERSCORE,
                                    Space,
                                EndGroup,
                                SpaceS,
                            EndGroup,
                            
                            Space,
                        EndLine,
#endif I_WISH_TRITON_WORKED

                        Space,
                        BeginLine,
                            Space,
                            TextNR("Offset"),
                            SpaceS,

                            HorizGroupAC,
                                IntegerBox(0, EDIT_OFFSET_ID, 6),
                                Space,
                                TextNR("Length"),
                                SpaceS,
                                IntegerBox(0, EDIT_LENGTH_ID, 6),
                                Space,
                            EndGroup,
                        EndLine,

                        Space,
                        BeginLine,
                            Space,
                            TextNR("Line"),
                            SpaceS,
                            IntegerBox(NULL, EDIT_GOTO_ID, 4),
                            Space,
                        EndLine,
                        Space,
                    EndArray,
                EndGroup,
            EndGroup,

            Space,
        EndGroup,

        Space,

        HorizGroupE,
            Space,
            ButtonR("Okay", EDIT_OKAY_ID),
            Space,
            Button("_Delete", EDIT_DELETE_ID),
            Space,
        EndGroup,

        Space,

    EndGroup,

EndProject
};
///

/// OptionsOutline
ProjectDefinition(OptionsOutline)
{
    WindowID(WINDOW_OPTIONS_ID),
        WindowTitle("Select options"),
        ScreenTitle(ScrTitle),
        WindowBackfillWin,
        WindowPosition(TRWP_CENTERDISPLAY),
        WindowDimensions(&OptionsDimensions),

    BeginMenu("Settings"),
        MenuItem("O_Open...", OPTIONS_MENU_PROJECT_OPEN_ID),
        MenuItem("Save as...", OPTIONS_MENU_PROJECT_SAVEAS_ID),

    HorizGroupE,
        Space,

        VertGroupA,
            Space,

            GroupBox, ObjectBackfillB,
            LineArray,
                Space,
                BeginLine,
                    Space,
                    CheckBoxText("Autodocs", OPTIONS_AUTODOC_ID),
                    Space,
                    CheckBoxText("C includes", OPTIONS_C_ID),
                    Space,
                    CheckBoxText("E includes", OPTIONS_E_ID),
                    Space,
                    CheckBoxText("Asm includes", OPTIONS_ASM_ID),
                    Space,
                EndLine,

                Space,
                BeginLineI,
                    HorizSeparator,
                EndLine,

                Space,
                BeginLine,
                    Space,
                    HorizGroupS,
                        TextN(""),
                    EndGroup,
                    Space,
                    CheckBoxText("#define", OPTIONS_C_DEFINE_ID),
                    Space,
                    CheckBoxText("CONST", OPTIONS_E_CONST_ID),
                    Space,
                    CheckBoxText("EQU/BITDEF", OPTIONS_ASM_EQU_ID),
                    Space,
                EndLine,

                Space,
                BeginLine,
                    Space,
                    HorizGroupS,
                        TextN(""),
                    EndGroup,
                    Space,
                    CheckBoxText("struct/union", OPTIONS_C_STRUCT_ID),
                    Space,
                    CheckBoxText("OBJECT", OPTIONS_E_OBJECT_ID),
                    Space,
                    CheckBoxText("STRUCTURE", OPTIONS_ASM_STRUCTURE_ID),
                    Space,
                EndLine,

                Space,
                BeginLine,
                    Space,
                    HorizGroupS,
                        TextN(""),
                    EndGroup,
                    Space,
                    CheckBoxText("typedef", OPTIONS_C_TYPEDEF_ID),
                    Space,
                    CheckBoxText("PROC", OPTIONS_E_PROC_ID),
                    Space,
                    CheckBoxText("MACRO", OPTIONS_ASM_MACRO_ID),
                    Space,
                EndLine,

                Space,
            EndArray,
            Space,

            GroupBox, ObjectBackfillB,
            HorizGroup,
                Space,
                VertGroup,
                    Space,
                    CheckBoxText("Scan drawers recursively", OPTIONS_RECURSIVELY_ID),
                    Space,
                    CheckBoxText("Keep files without references", OPTIONS_KEEPEMPTY_ID),
                    Space,
                EndGroup,
                Space,
                VertGroup,
                    Space,
                    HorizGroupC,
                        TextID("Unrecognized files", OPTIONS_UNKNOWNFILES_ID),
                        Space,
                        CycleGadget(FileTypeOptions, 0, OPTIONS_UNKNOWNFILES_ID),
                    EndGroup,
                    Space,
                EndGroup,
                Space,
            EndGroup,
            Space,

            HorizGroupE,
                Button("_Save", OPTIONS_SAVE_ID),
                Space,
                Button("_Use", OPTIONS_USE_ID),
                Space,
                Button("_Cancel", OPTIONS_CANCEL_ID),
            EndGroup,
            Space,

        EndGroup,
        Space,

    EndGroup,

EndProject
};
///

/// ReqTools stubs for varargs functions
LONG
rtChangeReqAttr(APTR req, ULONG Tag, ...)
{
    va_list args;

    va_start(args, req);
    return rtChangeReqAttrA(req, args);
}

ULONG
rtEZRequestTags(char *bodyfmt, char *gadfmt, struct rtReqInfo *reqinfo, APTR argarray, ULONG Tag, ...)
{
    va_list args;

    va_start(args, argarray);
    return rtEZRequestA(bodyfmt, gadfmt, reqinfo, argarray, args);
}

APTR
rtFileRequest(struct rtFileRequester *filereq, char *filename, char *title, ULONG Tag, ...)
{
    va_list args;

    va_start(args, title);
    return rtFileRequestA(filereq, filename, title, args);
}
///
